﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DynamicColumns.Attached
{
    using System.Windows;
    using System.Windows.Controls;

    using DynamicColumns.Data;

    using Telerik.Windows.Controls.GridView;

    public class TemplateSelector : DataTemplateSelector
    {
        private List<ColumnDataTemplate> columnDataTemplates = new List<ColumnDataTemplate>();

        public List<ColumnDataTemplate> ColumnDataTemplates
        {
            get
            {
                return this.columnDataTemplates;
            }
        }

        public override System.Windows.DataTemplate SelectTemplate(object item, System.Windows.DependencyObject container)
        {
            DataTemplate dataTemplate = base.SelectTemplate(item, container);

            GridViewCell gridViewCell = container as GridViewCell;

            if (gridViewCell != null && gridViewCell.Column != null)
            {
                ColumnMetadata columnMetadata = DataCreator.ColumnMetadatas.FirstOrDefault(c => c.Name == gridViewCell.Column.UniqueName);

                if (columnMetadata != null)
                {
                    ColumnDataTemplate columnDataTemplate = this.ColumnDataTemplates.FirstOrDefault(c => c.ColumnPrecision == columnMetadata.Precision);

                    if (columnDataTemplate != null)
                    {
                        dataTemplate = columnDataTemplate.DataTemplate;
                    }
                }
            }

            return dataTemplate;
        }
    }
}
