﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DynamicColumns.ViewModels
{
    using System.Data;
    using System.Windows.Input;

    using DynamicColumns.Data;

    using Microsoft.Practices.Prism.Commands;

    public class DataViewModel : ViewModelBase
    {
        private ICommand loadCommand;

        private DataTable dataTable;

        public DataTable DataTable
        {
            get
            {
                return this.dataTable;
            }

            set
            {
                this.dataTable = value;
                this.RaisePropertyChanged(() => this.DataTable);
            }
        }

        public ICommand LoadCommand
        {
            get
            {
                return this.loadCommand ?? (this.loadCommand = new DelegateCommand(this.Load));
            }
        }

        private void Load()
        {
            this.DataTable = DataCreator.Create();
        }
    }
}
